// watch all your go git repos
package main

import (
	"go.wit.com/dev/alexflint/arg"
	"go.wit.com/gui"
	"go.wit.com/lib/gadgets"
	"go.wit.com/lib/protobuf/forgepb"
	"go.wit.com/lib/protobuf/gitpb"
)

var me *autoType

type autoType struct {
	pp             *arg.Parser   // for parsing the command line args.  Yay to alexf lint!
	myGui          *gui.Node     // the gui handle itself
	releaseReasonS string        // = "gocui dropdown select"
	release        releaseStruct // notsure
	reposbox       *gui.Node     // notsure
	reposgrid      *gui.Node     // notsure
	reposgroup     *gui.Node     // notsure
	current        *gitpb.Repo   // tracks the next repo to publish
	found          *gitpb.Repos  // stores the list of repos to process things on
	done           []string      // gopaths for repos already published

	// this is the repo we are starting in
	// make sure it never changes so go.mod and go.sum are always there
	// 'go get' is called from here
	startRepo *gitpb.Repo

	// guireleaser window
	mainWindow *gadgets.BasicWindow
	mainBox    *gui.Node

	forge *forgepb.Forge // your customized repo preferences and settings

	// checkbox for --dry-run
	autoDryRun *gui.Node

	// checkbox for intermittent scanning
	scanEveryMinute *gui.Node

	// The current working directory
	autoWorkingPwd *gadgets.OneLiner

	// shows what directory being used as ~/go/src
	goSrcPwd *gadgets.OneLiner

	// button to download everything
	downloadEverythingButton *gui.Node

	// button to delete everythign ~/go/src & ~/go/pkg
	deleteGoSrcPkgB *gui.Node

	// button to set all repo branches to master
	setBranchesToMasterB *gui.Node

	// show the time it took to do a scan
	duration *gui.Node
}
